package com.caimei.module.pay.dao;

import com.caimei.module.base.entity.po.SeconHandProduct;
import com.caimei.module.base.entity.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;

/**
 * Description
 *
 * @author : plf
 * @date : 2020/5/9
 */
@Mapper
public interface PayDao {
    OrderVo findOrder(Integer orderId);

    List<DiscernReceiptVo> getDiscernReceipt(OrderVo order);

    void updateSelective(OrderVo order);

    void insertDiscernReceipt(DiscernReceiptVo discernReceipt);

    void insertOrderRelation(OrderRelationVo relation);

    OrderPayLinkVo findOrderPayLink(@Param("orderId") Long orderId, @Param("amount") BigDecimal amount);

    void updateOrderPayLink(OrderPayLinkVo orderPayLink);

    void insertOrderPayLink(OrderPayLinkVo orderPayLink);

    OrderPayLinkVo getOrderPayLink(String linkLogo);

    UserVo findUser(Long userID);

    List<OrderProductVo> fandAllOrderProduct(Integer orderId);

    void updateSeconHand(SeconHandProduct seconHandProduct);

    void insertSplitAccount(SplitAccount splitAccount);

    void updateSplitAccountByPay(String mbOrderId);

    /**
     * 修改用户余额
     *
     * @param userMoney
     * @param ableUserMoney
     * @param userId
     */
    void updateUserMoney(@Param("userMoney") BigDecimal userMoney, @Param("ableUserMoney") BigDecimal ableUserMoney, @Param("userId") Integer userId);

    /**
     * 新增余额收支记录
     *
     * @param balanceRecord
     */
    void insertBalanceRecord(BalanceRecordVo balanceRecord);

    /**
     * 获取线上支付开关状态
     */
    Integer getPayOnLineSwitch();
}
